## lomiri-teleports-app 1.21

=== CMakeLists.txt ===
project(teleports C CXX)
cmake_minimum_required(VERSION 3.0.0)
include(FindPkgConfig)

# Use CCache speed up build process
find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(GNUInstallDirs)

find_package(Qt5Core)
find_package(Qt5Qml)
find_package(Qt5Quick)
find_package(Qt5Concurrent)
find_package(Qt5QuickControls2)

# Automatically create moc files
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

# Components PATH
execute_process(
    COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
    OUTPUT_VARIABLE ARCH_TRIPLET
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

set(QT_IMPORTS_DIR "lib/${ARCH_TRIPLET}")

set(PROJECT_NAME "teleports")
set(FULL_PROJECT_NAME "teleports.ubports")
set(DATA_DIR ${CMAKE_INSTALL_PREFIX})
set(DESKTOP_FILE_NAME ${PROJECT_NAME}.desktop)
set(CURRENT_LIBRARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/libs)

# Sets BUILD_VERSION: Either tag of the current git HEAD or devel build version with git hash
execute_process(
  COMMAND git describe --tags --abbrev=0 --exact-match
  OUTPUT_VARIABLE BUILD_VERSION_RAW
  OUTPUT_STRIP_TRAILING_WHITESPACE
  ERROR_QUIET
  )
if(NOT BUILD_VERSION_RAW)
  execute_process(
    COMMAND git describe --tags --abbrev=0
    OUTPUT_VARIABLE LAST_VERSION_RAW
    OUTPUT_STRIP_TRAILING_WHITESPACE
    ERROR_QUIET
    )
  execute_process(
    COMMAND git rev-parse --short HEAD
    OUTPUT_VARIABLE GIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
    ERROR_QUIET
    )
  string(TIMESTAMP BUILD_VERSION_RAW "${LAST_VERSION_RAW}.%y%m%d%H%M%S" UTC)
  message(STATUS "Development build. Git hash is: ${GIT_HASH}")
endif(NOT BUILD_VERSION_RAW)
string(SUBSTRING ${BUILD_VERSION_RAW} 1 -1 BUILD_VERSION)
message(STATUS "Build version is: ${BUILD_VERSION}")

#Version for the app is set in app/CMakeLists.txt
configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION ${DATA_DIR})
install(FILES ${PROJECT_NAME}.apparmor DESTINATION ${DATA_DIR})
install(FILES ${PROJECT_NAME}.content-hub DESTINATION ${DATA_DIR})
install(FILES ${PROJECT_NAME}.url-dispatcher DESTINATION ${DATA_DIR})
install(DIRECTORY assets DESTINATION ${DATA_DIR})

# Translations
file(GLOB_RECURSE I18N_SRC_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/po push/*.cpp libs/qtdlib/*.cpp app/qml/*.qml app/qml/*.js)
list(APPEND I18N_SRC_FILES ${DESKTOP_FILE_NAME}.in.h)

find_program(INTLTOOL_MERGE intltool-merge)
if(NOT INTLTOOL_MERGE)
    message(FATAL_ERROR "Could not find intltool-merge, please install the intltool package")
endif()
find_program(INTLTOOL_EXTRACT intltool-extract)
if(NOT INTLTOOL_EXTRACT)
    message(FATAL_ERROR "Could not find intltool-extract, please install the intltool package")
endif()

add_custom_target(${DESKTOP_FILE_NAME} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE_NAME}..."
    COMMAND LC_ALL=C ${INTLTOOL_MERGE} -d -u ${CMAKE_SOURCE_DIR}/po ${CMAKE_SOURCE_DIR}/${DESKTOP_FILE_NAME}.in ${DESKTOP_FILE_NAME}
    COMMAND sed -i 's/${PROJECT_NAME}-//g' ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_NAME}
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_NAME} DESTINATION ${DATA_DIR})

add_subdirectory(po)
add_subdirectory(libs)
add_subdirectory(app)
add_subdirectory(push)
add_subdirectory(common)

# Make source files visible in qtcreator
# We don't need to add plugin sources here as they get exposed
# via the library target.
file(GLOB_RECURSE PROJECT_SRC_FILES
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    qml/*.qml
    qml/*.js
    *.json
    *.json.in
    *.apparmor
    *.desktop.in
)

add_custom_target(${PROJECT_NAME}_FILES ALL SOURCES ${PROJECT_SRC_FILES})

=== app/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Core Quick Multimedia REQUIRED)

find_package(QuickFlux REQUIRED)
find_package(rlottie REQUIRED)
find_package(rLottieQml REQUIRED)

#"qtdclient.cpp" "qtdthread.cpp" "qml.qrc"
add_definitions(-DBUILD_VERSION="${BUILD_VERSION}" -DGIT_HASH="${GIT_HASH}" -DQT_MESSAGELOGCONTEXT)
add_executable(${PROJECT_NAME} "main.cpp" "messagedelegatemap.cpp" "messagecontentdelegatemap.cpp" "ui-tools/offloadingimageprovider.cpp" "qml/qml.qrc" "qml/icons/icons.qrc")
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Quick Qt5::QuickControls2 QuickFlux::quickflux QTdlib rLottieQml::rLottieQml)

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

list(APPEND QML_DIRS "plugins")
set(QML_IMPORT_PATH "${QML_DIRS}")

=== common/CMakeLists.txt ===
add_subdirectory(auxdb)

=== libs/CMakeLists.txt ===
add_subdirectory(qtdlib)

=== po/CMakeLists.txt ===
include(FindGettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${FULL_PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)
file(GLOB PO_FILES *.po)

# Creates the .pot file containing the translations template
add_custom_target(${POT_FILE} ALL
    COMMENT "Generating translation template"
    COMMAND ${INTLTOOL_EXTRACT} --update --type=gettext/ini
        --srcdir=${CMAKE_SOURCE_DIR} ${DESKTOP_FILE_NAME}.in

    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
        -D ${CMAKE_CURRENT_SOURCE_DIR}
        -D ${CMAKE_CURRENT_BINARY_DIR}
        --from-code=UTF-8
        --c++ --qt --language=javascript --add-comments=TRANSLATORS
        --keyword=tr --keyword=tr:1,2 --keyword=N_ --keyword=_
        --package-name='${DOMAIN}'
        --sort-by-file
        ${I18N_SRC_FILES}
    COMMAND ${CMAKE_COMMAND} -E copy ${POT_FILE} ${CMAKE_CURRENT_SOURCE_DIR})

# Builds the binary translations catalog for each language
# it finds source translations (*.po) for
foreach(PO_FILE ${PO_FILES})
    get_filename_component(LANG ${PO_FILE} NAME_WE)
    gettext_process_po_files(${LANG} ALL PO_FILES ${PO_FILE})
    set(INSTALL_DIR ${CMAKE_INSTALL_LOCALEDIR}/${LANG}/LC_MESSAGES)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
            DESTINATION ${INSTALL_DIR}
            RENAME ${DOMAIN}.mo)
endforeach(PO_FILE)

=== push/CMakeLists.txt ===
find_package(Qt5Gui REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Widgets REQUIRED)

set(SOURCES
    push.cpp
    pushhelper.cpp)

add_executable(push ${SOURCES} )

target_link_libraries(push Qt5::Core Qt5::Widgets Qt5::Network Qt5::DBus Qt5::Sql auxdb)

install(FILES push-apparmor.json DESTINATION push)
install(FILES push-helper.json DESTINATION push)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/push DESTINATION push)

=== common/auxdb/CMakeLists.txt ===
find_package(Qt5Sql REQUIRED)
find_package(Qt5DBus REQUIRED)

set(SOURCES
    auxdb.cpp
    avatarmaptable.cpp
    postal-client.cpp
)

add_library(auxdb STATIC ${SOURCES} )
target_link_libraries(auxdb Qt5::Core Qt5::Sql Qt5::DBus)

=== libs/qtdlib/CMakeLists.txt ===
project(qtdlib C CXX)
cmake_minimum_required(VERSION 3.0.0)

set(DEVICE_MODEL "Ubuntu Touch")
set(SYSTEM_VERSION "unknown")

if (DEFINED ENV{SDK_FRAMEWORK})
    string(REGEX MATCH "[0-9]+\\.[0-9]+" SYSTEM_VERSION  $ENV{SDK_FRAMEWORK})
endif()

#set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Td 1.8.11 REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5Positioning REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Multimedia REQUIRED)

pkg_search_module(THUMBNAILER REQUIRED liblomiri-thumbnailer-qt)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QTDLIB "QTdlib")

set(
    SRC
    # todo
    # messages/content/qtdmessageexpiredphoto.cpp
    # messages/content/qtdmessageexpiredvideo.cpp
    # messages/content/qtdmessagegame.cpp
    # messages/content/qtdmessagegamescore.cpp
    # messages/content/qtdmessageinvoice.cpp
    # messages/content/qtdmessagepassportdatareceived.cpp
    # messages/content/qtdmessagepassportdatasent.cpp
    # messages/content/qtdmessagepaymentsuccessful.cpp
    # messages/content/qtdmessagepaymentsuccessfulbot.cpp
    # messages/content/qtdmessagevenue.cpp
    # messages/content/qtdmessagewebsiteconnected.cpp
    # messages/requests/content/qtdinputmessageanimation.cpp
    # messages/requests/content/qtdinputmessageaudio.cpp
    # messages/requests/content/qtdinputmessagecontact.cpp
    # messages/requests/content/qtdinputmessagedocument.cpp
    # messages/requests/content/qtdinputmessageforwarded.cpp
    # messages/requests/content/qtdinputmessagegame.cpp
    # messages/requests/content/qtdinputmessageinvoice.cpp
    # messages/requests/content/qtdinputmessagesticker.cpp
    # messages/requests/content/qtdinputmessagevenue.cpp
    # messages/requests/content/qtdinputmessagevideo.cpp
    # messages/requests/content/qtdinputmessagevideoNote.cpp
    # messages/requests/content/qtdinputmessagevoiceNote.cpp
	# end todo
    auth/qtdauthcode.cpp
    auth/qtdauthmanager.cpp
    auth/qtdauthparams.cpp
    auth/qtdauthstate.cpp
    auth/qtdauthstatefactory.cpp
    auth/requests/qtdauthcoderesponse.cpp
    auth/requests/qtdauthregistrationresponse.cpp
    auth/requests/qtdauthdeleteaccountresponse.cpp
    auth/requests/qtdauthencryptionkeyresponse.cpp
    auth/requests/qtdauthlogoutresponse.cpp
    auth/requests/qtdauthparametersresponse.cpp
    auth/requests/qtdauthpasswordresponse.cpp
    auth/requests/qtdauthphonenumberresponse.cpp
    auth/requests/qtdauthresendcoderequest.cpp
    call/qtdcalldiscardreason.cpp
    chat/qtdbasicgroupchat.cpp
    chat/qtdchat.cpp
    chat/qtdchatadministratorrights.cpp
    chat/qtdchataction.cpp
    chat/qtdchatactionbar.cpp
    chat/qtdchatactionfactory.cpp
    chat/qtdchatlistmodel.cpp
    chat/qtdchatlistsortfiltermodel.cpp
    chat/qtdchatmember.cpp
    chat/qtdchatmemberstatus.cpp
    chat/qtdchatpermissions.cpp
    chat/qtdchattype.cpp
    chat/qtdchattypefactory.cpp
    chat/qtdchatlist.cpp
    chat/qtdsecretchat.cpp
    chat/qtdsecretchatstate.cpp
    chat/qtdsupergroupchat.cpp
    chat/qtdchatinvitelinkinfo.cpp
    chat/qtdchatposition.cpp
    chat/requests/qtdclosechatrequest.cpp
    chat/requests/qtdclosesecretchatrequest.cpp
    chat/requests/qtdcreateprivatechatrequest.cpp
    chat/requests/qtdcreatenewsecretchatrequest.cpp
    chat/requests/qtddeletechathistoryrequest.cpp
    chat/requests/qtdgetbasicgrouprequest.cpp
    chat/requests/qtdgetchatrequest.cpp
    chat/requests/qtdgetchatsrequest.cpp
    chat/requests/qtdgetsecretchatrequest.cpp
    chat/requests/qtdgetsupergroupfullinforequest.cpp
    chat/requests/qtdgetsupergrouprequest.cpp
    chat/requests/qtdleavechatrequest.cpp
    chat/requests/qtdloadchatsrequest.cpp
    chat/requests/qtdopenchatrequest.cpp
    chat/requests/qtdreportchatrequest.cpp
    chat/requests/qtdsendchatactionrequest.cpp
    chat/requests/qtdsetchatdraftrequest.cpp
    chat/requests/qtdsetchattitlerequest.cpp
    chat/requests/qtdsetpinnedchatsrequest.cpp
    chat/requests/qtdforwardmessagesrequest.cpp
    chat/requests/qtdclosesecretchatrequest.cpp
    chat/requests/qtdsetchatnotificationsettings.cpp
    chat/requests/qtdsearchchatmessagesrequest.cpp
    chat/requests/qtdsearchpublicchatrequest.cpp
    chat/requests/qtdjoinchatrequest.cpp
    chat/requests/qtdcheckchatinvitelinkrequest.cpp
    chat/requests/qtdjoinchatbyinvitelinkrequest.cpp
    chat/requests/qtdsetchatmessagettlrequest.cpp
    chat/requests/qtdchatreportreason.cpp
    client/qtdclient.cpp
    client/qtdhandle.cpp
    client/qtdthread.cpp
    client/requests/qtdcloserequest.cpp
    common/qabstractint64id.cpp
    common/qabstracttdobject.cpp
    common/qtdhelpers.cpp
    common/qtdint.cpp
    common/qtdrequest.cpp
    common/qtdresponse.cpp
    connections/qtdconnectionstate.cpp
    connections/qtdconnectionstatefactory.cpp
    connections/qtdconnectionmanager.cpp
    files/qtdanimation.cpp
    files/qtdaudio.cpp
    files/qtddocument.cpp
    files/qtddownloadfilerequest.cpp
    files/qtdfile.cpp
    files/qtdlocalfile.cpp
    files/qtdphoto.cpp
    files/qtdphotos.cpp
    files/qtdphotosize.cpp
    files/qtdremotefile.cpp
    files/qtdsticker.cpp
    files/qtdvideo.cpp
    files/qtdvideonote.cpp
    files/qtdvoicenote.cpp
    files/qtdthumbnailformat.cpp
    files/qtdthumbnail.cpp
    files/qtdminithumbnail.cpp
    files/sticker/qtdstickertype.cpp
    files/sticker/qtdstickerformat.cpp
    messages/content/qtdformattedtext.cpp
    messages/content/qtdmessageanimation.cpp
    messages/content/qtdmessageunreadlabel.cpp
    messages/content/qtdmessageaudio.cpp
    messages/content/qtdmessagebasicgroupchatcreate.cpp
    messages/content/qtdmessagecall.cpp
    messages/content/qtdmessagechatchangetitle.cpp
    messages/content/qtdmessagechataddmembers.cpp
    messages/content/qtdmessagechatchangephoto.cpp
    messages/content/qtdmessagechatdeletemember.cpp
    messages/content/qtdmessagechatdeletephoto.cpp
    messages/content/qtdmessagechatjoinbylink.cpp
    messages/content/qtdmessagechatsetmessageautodeletetime.cpp
    messages/content/qtdmessagechatupgradefrom.cpp
    messages/content/qtdmessagechatupgradeto.cpp
    messages/content/qtdmessagecustomserviceaction.cpp
    messages/content/qtdmessagecontactregistered.cpp
    messages/content/qtdmessagedate.cpp
    messages/content/qtdmessagedocument.cpp
    messages/content/qtdmessagelocation.cpp
    messages/content/qtdmessagephoto.cpp
    messages/content/qtdmessagepoll.cpp
    messages/content/qtdmessagesticker.cpp
    messages/content/qtdmessagesupergroupchatcreate.cpp
    messages/content/qtdmessagetext.cpp
    messages/content/qtdmessagevideo.cpp
    messages/content/qtdmessagevideonote.cpp
    messages/content/qtdmessagevoicenote.cpp
    messages/content/qtdpoll.cpp
    messages/content/qtdpolloption.cpp
    messages/content/qtdpolltype.cpp
    messages/content/qtdtextentity.cpp
    messages/content/qtdtextentitytype.cpp
    messages/content/qtdlocation.cpp
    messages/content/qtdwebpage.cpp
    messages/content/qtdmessagecontact.cpp
    messages/content/qtdmessageunsupported.cpp
    messages/content/qtdmessagescreenshottaken.cpp
    messages/content/qtdmessagepinmessage.cpp
    messages/qtdchatstate.cpp
    messages/qtddraftmessage.cpp
    messages/qtdmessage.cpp
    messages/qtdmessagecontent.cpp
    messages/qtdmessagecontentfactory.cpp
    messages/qtdmessageinteractioninfo.cpp
    messages/qtdmessagelink.cpp
    messages/qtdmessagesender.cpp
    messages/qtdmessagesenderuser.cpp
    messages/qtdmessagesenderchat.cpp
    messages/qtdmessagelistmodel.cpp
    messages/qtdmessagesendingstate.cpp
    messages/qtdmessageschedulingstate.cpp
    messages/replymarkup/qtdkeyboardbutton.cpp
    messages/replymarkup/qtdkeyboardbuttontype.cpp
    messages/replymarkup/qtdreplymarkup.cpp
    messages/forwardinfo/qtdmessageforwardinfo.cpp
    messages/forwardinfo/qtdmessageforwardorigin.cpp
    messages/forwardinfo/qtdmessageforwardoriginfactory.cpp
    messages/requests/content/qtdinputthumbnail.cpp
    messages/requests/content/qtdinputmessagedocument.cpp
    messages/requests/content/qtdinputmessagephoto.cpp
    messages/requests/content/qtdinputmessagecontact.cpp
    messages/requests/content/qtdinputmessagevideo.cpp
    messages/requests/content/qtdinputmessageaudio.cpp
    messages/requests/content/qtdinputmessagetext.cpp
    messages/requests/content/qtdinputmessageaudio.cpp
    messages/requests/content/qtdinputmessagevideo.cpp
    messages/requests/content/qtdinputmessagevoicenote.cpp
    messages/requests/content/qtdinputmessagelocation.cpp
    messages/requests/content/qtdinputmessagesticker.cpp
    messages/requests/qtddeletemessagesrequest.cpp
    messages/requests/qtdgetchathistoryrequest.cpp
    messages/requests/qtdeditmessagecaptionrequest.cpp
    messages/requests/qtdeditmessagetextrequest.cpp
    messages/requests/qtdgetmessagerequest.cpp
    messages/requests/qtdgetmessagelinkrequest.cpp
    messages/requests/qtdinputmessagecontent.cpp
    messages/requests/qtdinputmessagecontentattachmentcaption.cpp
    messages/requests/qtdinputmessagecontentfactory.cpp
    messages/requests/qtdsendmessagerequest.cpp
    messages/requests/qtdviewmessagesrequest.cpp
    messages/requests/qtdopenmessagecontentrequest.cpp
    messages/requests/qtdmessagesendoptions.cpp
    messages/requests/qtdsetpollanswerrequest.cpp
    messages/requests/qtdtogglemessagesenderisblockedrequest.cpp
    messages/requests/qtdsendmessagealbumrequest.cpp
    models/QmlObjectListModel.cpp
    models/QmlVariantListModel.cpp
    network/qtdnetworktype.cpp
    network/requests/qtdsetnetworktype.cpp
    notifications/qtdenablenotifications.cpp
    notifications/qtdnotificationsettings.cpp
    notifications/qtdregisterdevicerequest.cpp
    quick/plugin.cpp
    quick/users.cpp
    quick/contacts.cpp
    settings/qtdproxy.cpp
    settings/qtdproxytype.cpp
    settings/qtdsettings.cpp
    settings/requests/qtdgetproxiesrequest.cpp
    settings/requests/qtdaddproxyrequest.cpp
    settings/requests/qtdeditproxyrequest.cpp
    settings/requests/qtdenableproxyrequest.cpp
    settings/requests/qtddisableproxyrequest.cpp
    settings/requests/qtdpingproxyrequest.cpp
    settings/requests/qtdremoveproxyrequest.cpp
    stickers/qtdstickersets.cpp
    stickers/qtdstickerset.cpp
    user/qtdemojistatus.cpp
    user/qtdprofilephoto.cpp
    user/qtduser.cpp
    user/qtdcontact.cpp
    user/qtduserfullinfo.cpp
    user/qtdusernames.cpp
    user/qtdusers.cpp
    user/qtduserstatus.cpp
    user/qtduserstatusfactory.cpp
    user/qtdusertype.cpp
    user/requests/qtdblockuserrequest.cpp
    user/requests/qtdgetuserrequest.cpp
    user/requests/qtdimportcontactsrequest.cpp
    user/requests/qtdremovecontactsrequest.cpp
    user/requests/qtdgetcontactsrequest.cpp
    user/requests/qtdgetuserfullinforequest.cpp
    user/requests/qtdsearchuserbyphonenumberrequest.cpp
    utils/qtdtextformatter.cpp
    utils/qtdmediatools.cpp
)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

add_library(${QTDLIB} SHARED ${SRC})
target_link_libraries(${QTDLIB} Qt5::Core Qt5::Quick Qt5::Widgets Qt5::Qml Qt5::Concurrent Qt5::Positioning Qt5::Multimedia Td::tdjson Td::tdapi auxdb)
target_include_directories(${QTDLIB} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${THUMBNAILER_INCLUDE_DIRS})
target_link_libraries(${QTDLIB} ${THUMBNAILER_LIBRARIES})
get_filename_component(QTDLIB_DIR ${CMAKE_CURRENT_SOURCE_DIR} DIRECTORY)

target_compile_definitions(${QTDLIB} PRIVATE -DDEVICE_MODEL="${DEVICE_MODEL}")
target_compile_definitions(${QTDLIB} PRIVATE -DSYSTEM_VERSION="${SYSTEM_VERSION}")

if(DEFINED ENV{TDLIB_DEBUG})
    target_compile_definitions(${QTDLIB} PRIVATE TDLIB_DEBUG)
endif()

install(TARGETS ${QTDLIB} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

## lomiri-teleports-app 1.20

=== debian/changelog ===
lomiri-teleports-app (1.20-5) unstable; urgency=medium

  * debian/patches:
    + Add 0014_fix-bindtextdomain-when-not-a-click.patch. Don't set a custom
      .mo file path when not a click package.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 30 Jan 2025 18:47:16 +0100

lomiri-teleports-app (1.20-4) unstable; urgency=medium

  [ Robert Tari ]
  * debian/control:
    + Add missing runtime dependency: qml-module-qt-labs-platform.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 28 Jan 2025 04:17:19 +0100

lomiri-teleports-app (1.20-3) unstable; urgency=medium

  [ Cosima Neidahl ]
  * debian/*:
    + Switch to td1.8.11. (Closes: #1093771).

  [ Mike Gabriel ]
  * debian/control:
    + Assure correct libtd1.8.11(-dev) version in Build-Depends:
      libtd1.8.11-dev (>= 1.8.11~git20230202.3179d35+dfsg-2~).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 22 Jan 2025 21:34:49 +0100

lomiri-teleports-app (1.20-2) unstable; urgency=medium

  * debian/source/lintian-overrides:
    + Add file. Ignore long lines in app/qml/components/CountryCodes.js.
  * debian/patches:
    + Cherry-pick patch 0001 - 0013 (i.e. partially update patches 0001 - 0004)
      from TELEports upstream MR introducing DEB builds of TELEports.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 02 Jan 2025 13:45:43 +0100

lomiri-teleports-app (1.20-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1089005).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 04 Dec 2024 06:18:49 +0100

=== debian/control ===
Source: lomiri-teleports-app
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               gperf,
               intltool,
               liblomiri-thumbnailer-qt-dev,
               libquazip1-qt5-dev,
               librlottie-dev,
               libssl-dev,
               libtd1.8.11-dev (>= 1.8.11~git20230202.3179d35+dfsg-2~),
               pkgconf,
# qml-module-rlottie has the CMake module, prolly needs to be split up more?
               qml-module-rlottie,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtmultimedia5-dev,
               qtpositioning5-dev,
               qtquickcontrols2-5-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/apps/teleports
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-teleports-app/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-teleports-app.git

Package: lomiri-teleports-app
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtquick2,
         qml-module-qtquick-controls2,
         qml-module-qtquick-controls2-suru,
         qml-module-u1db,
         qml-module-lomiri-components,
         qml-module-lomiri-components-extras,
         qml-module-lomiri-layouts,
         qml-module-lomiri-content,
         qml-module-lomiri-thumbnailer,
         qml-module-lomiri-pushnotifications,
         qml-module-quickflux,
         qml-module-rlottie,
         qml-module-qt-labs-platform,
Description: Telegram Chat Client App for Lomiri Operating Environment
 This app is a much liked app for Ubuntu Touch's shell Lomiri. Ubuntu Touch is
 a mobile OS developed by the UBports Foundation. Lomiri is its operating
 environment optimized for touch based human-machine interaction, but
 also supports convergence (i.e. switching between tablet/phone and
 desktop mode).
 .
 This package provides Lomiri's TELEports App.

## lomiri-teleports-app 1.21

=== debian/changelog ===
lomiri-teleports-app (1.21-2) unstable; urgency=medium

  * debian/patches:
    + Add patches 0015_CMakeLists.txt-Support-building-with-CMake-4.patch
      and 0016_libs-qtdlib-CMakeLists.txt-Support-building-with-CMa.patch.
      Support building with CMake 4. (Closes: #1113247).
  * debian/control:
    + Add to D: field (lomiri-teleports-app): qml-module-qtmultimedia and
      qml-module-qtsysteminfo. (Closes: #1115949).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 30 Sep 2025 21:26:41 +0200

lomiri-teleports-app (1.21-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Trivially rebase patches 0001, 0004, 0006 and 0011.
  * debian/control:
    + Add to D: field: qml-module-lomiri-connectivity and qml-module-qtcontacts.
      (Closes: #1114019).
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 07 Sep 2025 00:10:00 +0200

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
                qtmultimedia5-dev,
                qtpositioning5-dev,
                qtquickcontrols2-5-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/apps/teleports
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-teleports-app/
@@ -30,16 +30,20 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
+         qml-module-qtmultimedia,
          qml-module-qtquick2,
          qml-module-qtquick-controls2,
          qml-module-qtquick-controls2-suru,
+         qml-module-qtsysteminfo,
          qml-module-u1db,
          qml-module-lomiri-components,
          qml-module-lomiri-components-extras,
+         qml-module-lomiri-connectivity,
          qml-module-lomiri-layouts,
          qml-module-lomiri-content,
          qml-module-lomiri-thumbnailer,
          qml-module-lomiri-pushnotifications,
+         qml-module-qtcontacts,
          qml-module-quickflux,
          qml-module-rlottie,
          qml-module-qt-labs-platform,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCLICK_MODE=OFF

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
opts="searchmode=plain, repacksuffix=+dfsg, dversionmangle=s/\+dfsg//" \
https://gitlab.com/ubports/development/apps/teleports/tags?sort=updated_desc -/archive/v?\d[\d.]+/teleports-@ANY_VERSION@@ARCHIVE_EXT@
